Index: XIOS/dev/branch_yushan/src/interface/c_attr/icinterpolate_domain_attr.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/interface/c_attr/icinterpolate_domain_attr.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/interface/c_attr/icinterpolate_domain_attr.cpp	(revision 1037)
@@ -18,25 +18,25 @@
   typedef xios::CInterpolateDomain* interpolate_domain_Ptr;
 
-  void cxios_set_interpolate_domain_mode(interpolate_domain_Ptr interpolate_domain_hdl, const char * mode, int mode_size)
+  void cxios_set_interpolate_domain_file(interpolate_domain_Ptr interpolate_domain_hdl, const char * file, int file_size)
   {
-    std::string mode_str;
-    if (!cstr2string(mode, mode_size, mode_str)) return;
+    std::string file_str;
+    if (!cstr2string(file, file_size, file_str)) return;
     CTimer::get("XIOS").resume();
-    interpolate_domain_hdl->mode.fromString(mode_str);
+    interpolate_domain_hdl->file.setValue(file_str);
     CTimer::get("XIOS").suspend();
   }
 
-  void cxios_get_interpolate_domain_mode(interpolate_domain_Ptr interpolate_domain_hdl, char * mode, int mode_size)
+  void cxios_get_interpolate_domain_file(interpolate_domain_Ptr interpolate_domain_hdl, char * file, int file_size)
   {
     CTimer::get("XIOS").resume();
-    if (!string_copy(interpolate_domain_hdl->mode.getInheritedStringValue(), mode, mode_size))
-      ERROR("void cxios_get_interpolate_domain_mode(interpolate_domain_Ptr interpolate_domain_hdl, char * mode, int mode_size)", << "Input string is too short");
+    if (!string_copy(interpolate_domain_hdl->file.getInheritedValue(), file, file_size))
+      ERROR("void cxios_get_interpolate_domain_file(interpolate_domain_Ptr interpolate_domain_hdl, char * file, int file_size)", << "Input string is too short");
     CTimer::get("XIOS").suspend();
   }
 
-  bool cxios_is_defined_interpolate_domain_mode(interpolate_domain_Ptr interpolate_domain_hdl)
+  bool cxios_is_defined_interpolate_domain_file(interpolate_domain_Ptr interpolate_domain_hdl)
   {
      CTimer::get("XIOS").resume();
-     bool isDefined = interpolate_domain_hdl->mode.hasInheritedValue();
+     bool isDefined = interpolate_domain_hdl->file.hasInheritedValue();
      CTimer::get("XIOS").suspend();
      return isDefined;
@@ -88,52 +88,3 @@
      return isDefined;
   }
-
-
-  void cxios_set_interpolate_domain_weight_filename(interpolate_domain_Ptr interpolate_domain_hdl, const char * weight_filename, int weight_filename_size)
-  {
-    std::string weight_filename_str;
-    if (!cstr2string(weight_filename, weight_filename_size, weight_filename_str)) return;
-    CTimer::get("XIOS").resume();
-    interpolate_domain_hdl->weight_filename.setValue(weight_filename_str);
-    CTimer::get("XIOS").suspend();
-  }
-
-  void cxios_get_interpolate_domain_weight_filename(interpolate_domain_Ptr interpolate_domain_hdl, char * weight_filename, int weight_filename_size)
-  {
-    CTimer::get("XIOS").resume();
-    if (!string_copy(interpolate_domain_hdl->weight_filename.getInheritedValue(), weight_filename, weight_filename_size))
-      ERROR("void cxios_get_interpolate_domain_weight_filename(interpolate_domain_Ptr interpolate_domain_hdl, char * weight_filename, int weight_filename_size)", << "Input string is too short");
-    CTimer::get("XIOS").suspend();
-  }
-
-  bool cxios_is_defined_interpolate_domain_weight_filename(interpolate_domain_Ptr interpolate_domain_hdl)
-  {
-     CTimer::get("XIOS").resume();
-     bool isDefined = interpolate_domain_hdl->weight_filename.hasInheritedValue();
-     CTimer::get("XIOS").suspend();
-     return isDefined;
-  }
-
-
-  void cxios_set_interpolate_domain_write_weight(interpolate_domain_Ptr interpolate_domain_hdl, bool write_weight)
-  {
-    CTimer::get("XIOS").resume();
-    interpolate_domain_hdl->write_weight.setValue(write_weight);
-    CTimer::get("XIOS").suspend();
-  }
-
-  void cxios_get_interpolate_domain_write_weight(interpolate_domain_Ptr interpolate_domain_hdl, bool* write_weight)
-  {
-    CTimer::get("XIOS").resume();
-    *write_weight = interpolate_domain_hdl->write_weight.getInheritedValue();
-    CTimer::get("XIOS").suspend();
-  }
-
-  bool cxios_is_defined_interpolate_domain_write_weight(interpolate_domain_Ptr interpolate_domain_hdl)
-  {
-     CTimer::get("XIOS").resume();
-     bool isDefined = interpolate_domain_hdl->write_weight.hasInheritedValue();
-     CTimer::get("XIOS").suspend();
-     return isDefined;
-  }
 }